<template>
  <q-layout view="hHr LpR ffr">
    <q-header overlay :class="headerClass + ' opacity-85'">
      <!-- :class="headerClass + ' bg-support'"> -->
      <q-toolbar>
        {{ $props }}
        <div class="row items-center full-width">
          <div class="col-11 offset-md-1 col-md-4">
            <q-toolbar-title>
              <q-btn class="q-py-sm" push flat no-caps to="/">
                <q-avatar size="xl" icon="img:icons/favicon-128x128.png" />
                &nbsp;
                <span style="font-size: 24px;">
                  theNexusCodes
                </span>
              </q-btn>
            </q-toolbar-title>
          </div>

          <div v-if="$q.screen.lt.md" class="col-1">
            <q-btn
              flat
              dense
              round
              icon="menu"
              aria-label="Menu"
              @click="leftDrawerOpen = !leftDrawerOpen"
            />
          </div>
          <div v-else class="col-md-6 row justify-end items-center q-gutter-md">
              <a class="text-h6 head-link" href="#usage">Use Cases</a>
              <a class="text-h6 head-link" href="#privacy">Security</a>
              <a class="text-h6 head-link" href="#how">How it works?</a>
              <a class="text-h6 head-link" href="#pricing">Pricing</a>
              <a class="text-h6 head-link" href="#data">Data</a>
              <q-btn
                no-caps
                dense
                to="request-access"
                text-color="white"
                style="font-size: 20px;"
                class="gradient-box-btn"
                label="Request access"
              />
          </div>
        </div>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      side="right"
      content-class="bg-alt-accent"
    >
      <q-list>
        <q-item-label header class="text-grey-4">
          Essential Links
        </q-item-label>
        <EssentialLink
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
        <q-item class="row justify-center q-mt-md">
          <q-btn
            no-caps
            dense
            to="request-access"
            text-color="white"
            style="font-size: 20px;"
            class="gradient-box-btn"
            label="Request access"
          />
        </q-item>
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>

    <q-scroll-observer @scroll="onScroll" />

    <q-footer class="bg-primary text-white row justify-evenly q-pt-sm">
      <div class="col-12 col-md-8">
        <div class="column items-center">
          <div class="row justify-center">
            <q-btn
              flat
              icon="fas fa-blog"
              type="a"
              target="blank"
              href="https://rebhu.blog"
            />
            <q-btn
              flat
              icon="mdi-twitter"
              type="a"
              target="blank"
              href="https://twitter.com/RebhuComputing"
            />
            <q-btn
              flat
              icon="mdi-reddit"
              type="a"
              target="blank"
              href="https://www.reddit.com/r/rebhu/"
            />
            <q-btn
              flat
              icon="mdi-gitlab"
              type="a"
              target="blank"
              href="https://gitlab.com/rebhu"
            />
            <q-btn
              flat
              icon="fab fa-gitter"
              type="a"
              target="blank"
              href="https://app.element.io/#/group/+rebhu:matrix.org"
            />
            <q-btn
              flat
              icon="mdi-discord"
              type="a"
              target="blank"
              href="https://discord.gg/ERYP5u6m2s"
            />
            <q-btn
              flat
              icon="fab fa-angellist"
              type="a"
              target="blank"
              href="https://angel.co/company/rebhu-computing"
            />
            <q-btn
              flat
              icon="mdi-linkedin"
              type="a"
              target="blank"
              href="https://www.linkedin.com/company/rebhu-computing"
            />
            <q-btn
              flat
              icon="mdi-instagram"
              type="a"
              target="blank"
              href="https://www.instagram.com/rebhu.computing/"
            />
            <q-btn
              flat
              icon="mdi-facebook"
              type="a"
              target="blank"
              href="https://www.facebook.com/rebhucomputing/"
            />
          </div>
          <q-toolbar class="row justify-between">
            <span class="text-center">Copyright &#169; 2021 Rebhu Computing</span>
            <span class="text-center">Made with &#9829; at Rebhu Computing</span>
          </q-toolbar>
        </div>
      </div>
    </q-footer>
  </q-layout>
</template>

<script lang="ts">
import EssentialLink from 'components/EssentialLink.vue';

const linksData = [
  {
    title: 'Use Cases',
    caption: 'Strategy, Research, and Digital History',
    icon: 'fab fa-superpowers',
    link: '#usage'
  },
  {
    title: 'Security',
    caption: 'You are not the product',
    icon: 'fas fa-user-secret',
    link: '#privacy'
  },
  {
    title: 'How it works?',
    caption: 'Three simple steps',
    icon: 'work',
    link: '#how'
  },
  {
    title: 'Pricing',
    caption: 'A plan that suits you',
    icon: 'mdi-cash',
    link: '#pricing'
  },
  {
    title: 'Data',
    caption: 'What complements data?',
    icon: 'mdi-database',
    link: '#data'
  },
];

import { defineComponent, ref } from '@vue/composition-api';

export default defineComponent({
  name: 'MainLayout',
  components: { EssentialLink },
  setup() {
    const leftDrawerOpen = ref(false);
    const essentialLinks = ref(linksData);

    return { leftDrawerOpen, essentialLinks };
  },

  data() {
    return {
      headerClass: 'transparent',
      headerPosition: 0,
    };
  },

  methods: {
    onScroll: function(info: {
      position: number;
      direction: string;
      directionChanged: boolean;
      inflexionPosition: number;
    }) {
      if (info.position < 100 && info.position >= 0) {
        this.headerClass = 'transparent'
      } else {
        this.headerClass = ''
      }
    }
  }
});
</script>
